/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.testframework;

import com.topcoder.testframework.web.DefaultWebApplicationServerTest;
import com.topcoder.testframework.web.PrepareTestEarTaskTest;
import com.topcoder.testframework.web.PrepareTestWarTaskTest;
import com.topcoder.testframework.web.TCFilterTestCaseTest;
import com.topcoder.testframework.web.TCJspTestCaseTest;
import com.topcoder.testframework.web.TCServletTestCaseTest;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;


/**
 * <p>This test case aggregates all Unit test cases.</p>
 *
 * @author TopCoder
 * @version 1.0
 */
public class UnitTests extends TestCase {

    /**
     * creates the test suite containing all unit tests.
     *
     * @return the test suite containing all unit tests
     */
    public static Test suite() {
        final TestSuite suite = new TestSuite();
        suite.addTest(new TestSuite(AntTaskInfoTest.class));
        suite.addTest(new TestSuite(ApplicationServerTest.class));
        suite.addTest(new TestSuite(CredentialPropertyTest.class));
        suite.addTest(new TestSuite(CredentialsElementTest.class));
        suite.addTest(new TestSuite(DataServerTest.class));
        suite.addTest(new TestSuite(ServerTest.class));
        suite.addTest(new TestSuite(ServerElementTest.class));
        suite.addTest(new TestSuite(ServerAppTestTaskTest.class));
        suite.addTest(new TestSuite(DefaultWebApplicationServerTest.class));
        suite.addTest(new TestSuite(TCFilterTestCaseTest.class));
        suite.addTest(new TestSuite(TCServletTestCaseTest.class));
        suite.addTest(new TestSuite(TCJspTestCaseTest.class));
        suite.addTest(new TestSuite(PrepareTestEarTaskTest.class));
        suite.addTest(new TestSuite(PrepareTestWarTaskTest.class));
        return suite;
    }

}
