/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.testframework.web;

import junit.framework.TestCase;
import org.apache.cactus.server.HttpServletRequestWrapper;
import org.apache.cactus.server.PageContextWrapper;
import org.apache.cactus.server.ServletConfigWrapper;

import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspWriter;
import java.io.IOException;


/**
 * This class contains the unit tests for {@link com.topcoder.testframework.web.TCJspTestCase}.
 *
 * @author TCSDEVELOPER
 * @version 1.0
 */
public class TCJspTestCaseTest extends TestCase {
    /**
     * This is a name used in test cases.
     */
    private static final String NAME = "testxxNamexx";
    /**
     * This is the instance to be tested. It is created in {@link #setUp()}.
     */
    private TCJspTestCase testCase;

    /**
     * This method tests {@link com.topcoder.testframework.web.TCJspTestCase#TCJspTestCase()} for correctness.
     */
    public void testNoArgCtor() {
        final TCJspTestCase instance = new TCJspTestCase();
        assertNull("constructor does not assign all fields", instance.getConfig());
        assertNull("constructor does not assign all fields", instance.getSession());
        assertNull("constructor does not assign all fields", instance.getRequest());
        assertNull("constructor does not assign all fields", instance.getResponse());
        assertNull("constructor does not assign all fields", instance.getName());
        assertNull("constructor does not assign all fields", instance.getOut());
        assertNull("constructor does not assign all fields", instance.getPageContext());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCJspTestCase#TCJspTestCase(String)} for correctness.
     */
    public void testOneArgCtor() {
        final TCJspTestCase instance = new TCJspTestCase(TCJspTestCaseTest.NAME);
        assertNull("constructor does not assign all fields", instance.getConfig());
        assertNull("constructor does not assign all fields", instance.getSession());
        assertNull("constructor does not assign all fields", instance.getRequest());
        assertNull("constructor does not assign all fields", instance.getResponse());
        assertNull("constructor does not assign all fields", instance.getOut());
        assertNull("constructor does not assign all fields", instance.getPageContext());
        assertEquals("constructor does not assign all fields", NAME, instance.getName());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCJspTestCase#getConfig()} for correctness.
     */
    public void testGetConfig() {
        assertNull(testCase.getConfig());
        final ServletConfigWrapper configWrapper = new ServletConfigWrapper(null);
        testCase.config = configWrapper;
        assertEquals(configWrapper, testCase.getConfig());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCJspTestCase#getSession()} for correctness.
     */
    public void testGetJspChain() {
        assertNull(testCase.getSession());
        final DummySession session = new DummySession();
        testCase.session = session;
        assertEquals(session, testCase.getSession());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCJspTestCase#getRequest()} for correctness.
     */
    public void testGetRequest() {
        assertNull(testCase.getRequest());
        final HttpServletRequestWrapper requestWrapper = new HttpServletRequestWrapper(null, null);
        testCase.request = requestWrapper;
        assertEquals(requestWrapper, testCase.getRequest());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCJspTestCase#getResponse()} for correctness.
     */
    public void testGetResponse() {
        assertNull(testCase.getResponse());

        final HttpServletResponse response = new DummyHttpServletResponse();
        testCase.response = response;
        assertEquals(response, testCase.getResponse());
    }

    /**
     * This method tests {@link TCJspTestCase#getOut()} for correctness.
     */
    public void testGetOut() {
        assertNull(testCase.getOut());

        final DummyJspWriter writer = new DummyJspWriter();
        testCase.out = writer;
        assertEquals(writer, testCase.getOut());
    }

    /**
     * This method tests {@link TCJspTestCase#getPageContext()} for correctness.
     */
    public void testGetPageContext() {
        assertNull(testCase.getOut());

        final PageContextWrapper pageContextWrapper = new PageContextWrapper(null, null);
        testCase.pageContext = pageContextWrapper;
        assertEquals(pageContextWrapper, testCase.getPageContext());
    }

    /**
     * This method does the test setup needed.
     *
     * @throws Exception in case some unexpected Exception occurs
     */
    protected void setUp() throws Exception {
        super.setUp();
        testCase = new TCJspTestCase();
    }

    /**
     * This is a dummy {@link JspWriter} instance. This is a mock implementation that does nothing and is only used to
     * serve as a non-<tt>null</tt> {@link JspWriter} instance in test cases.
     */
    private static class DummyJspWriter extends JspWriter {
        private DummyJspWriter() {
            super(0, false);
        }

        public void newLine() throws IOException {

        }

        public void print(final boolean b) throws IOException {

        }

        public void print(final char c) throws IOException {

        }

        public void print(final int i) throws IOException {

        }

        public void print(final long l) throws IOException {

        }

        public void print(final float v) throws IOException {

        }

        public void print(final double v) throws IOException {

        }

        public void print(final char[] chars) throws IOException {

        }

        public void print(final String string) throws IOException {

        }

        public void print(final Object object) throws IOException {

        }

        public void println() throws IOException {

        }

        public void println(final boolean b) throws IOException {

        }

        public void println(final char c) throws IOException {

        }

        public void println(final int i) throws IOException {

        }

        public void println(final long l) throws IOException {

        }

        public void println(final float v) throws IOException {

        }

        public void println(final double v) throws IOException {

        }

        public void println(final char[] chars) throws IOException {

        }

        public void println(final String string) throws IOException {

        }

        public void println(final Object object) throws IOException {

        }

        public void clear() throws IOException {

        }

        public void clearBuffer() throws IOException {

        }

        public void flush() throws IOException {

        }

        public void close() throws IOException {

        }

        public int getRemaining() {
            return 0;
        }

        public void write(final char[] cbuf, final int off, final int len) throws IOException {

        }
    }
}
